module ClientEngine
  	class ApplicationController < ActionController::Base
	    protect_from_forgery with: :exception
	    helper_method :sort_column, :sort_direction

	    def sort_column(class_name)
		    params[:sort] ||= ""
		    if params[:sort].split(".").count > 1
		      	clase = Object.const_get (params[:sort].split(".").last(2).first.titleize.gsub(" ", ""))
		      	if clase.column_names.include?(params[:sort].split(".").last.to_s) 
		        	[params[:sort].split(".").last(2).first.pluralize, params[:sort].split(".").last].join(".")
		      	else
		        	"#{class_name.titleize.parameterize.underscore.pluralize}.updated_at"
		      	end
		    else
		      	clase = Object.const_get (class_name)
		      	clase.column_names.include?(params[:sort]) ? "#{class_name.titleize.parameterize.underscore.pluralize}.#{params[:sort].to_s}" : "#{class_name.titleize.parameterize.underscore.pluralize}.updated_at"
		    end
		end

	  
	  	def sort_direction
	    	%w[asc desc].include?(params[:direction]) ? params[:direction] : "desc"
	  	end

	  	def get_client_data_from_afip
	  		timeout_in_seconds = 5
	      	begin
	        	Timeout::timeout(timeout_in_seconds) do
	        		response = [::Afip::Padron.new(dni: params[:document], tipo: "F").get_data, ::Afip::Padron.new(dni: params[:document], tipo: "M").get_data] unless params[:document].blank?
	          		render status: 200, json: response.compact.first
	        	end
	      	rescue
	      	  	render json: ["",""]
	      	end
	  	end
  	end
end
