module ClientEngine
  module ClientsHelper

  	### BEGIN SORTABLE ###
  	def sortable(column,class_name, title = nil)
	  	title ||= column.titleize
	  	if column.split(".").count >= 2
		  	css_class = (
		  		(column.split(".").last.to_s == sort_column(class_name).split(".").last.to_s) &&
		  		(column.split(".").last(2).first.pluralize.to_s == sort_column(class_name).split(".").last(2).first.pluralize.to_s)
		  		) ? "#{sort_direction}" : nil
		  	css_class = css_class == "asc" ? "long-arrow-down" : (css_class == "desc" ? "long-arrow-up" : nil)
		else
	  		css_class = column.split(".").last.to_s == sort_column(class_name).split(".").last.to_s ? "#{sort_direction}" : nil
	  		css_class = css_class == "asc" ? "long-arrow-down" : (css_class == "desc" ? "long-arrow-up" : nil)
	  	end
	  	column.split(".").to_s
	  	sort_column(class_name).split(".").to_s
	  	css_class

	  	direction = (column.split(".").last.to_s == sort_column(class_name).split(".").last.to_s && sort_direction == "asc") ? "desc" : "asc"
	  	link_to "#{fa_icon(css_class)} #{title}".html_safe, {sort: column, direction: direction, search: params[:search]}, {remote: true}
	end
	### END SORTABLE #####

  	### BEGIN HELPER TITULO ###
  	def titulo icono,texto
		@icono = icono
		@texto = texto
		content_for :title do
			content_tag :div, class: :row do
				concat(title_row)
			end
		end
	end

	def title_row
		content_tag :div,class:'col-xs-10 col-sm-11 col-md-11' do
			concat(title)
		end
	end

	def title
		content_tag :h1 do
			concat(fa_icon(@icono))
			concat(" " + @texto)
		end
	end
	### END HELPER TITULO #####

	### BEGIN SEARCH FORM CLIENTE ###
	def search_form_client path, link_text, link_path
		@path = path
		@link_text = link_text
		@link_path = link_path

		content_tag :div, id:'buscador' do
			concat(row)
		end
	end

	def row
		content_tag :div, class: 'row' do
			concat(column_div_form)
			concat(column_div_link)
		end
	end

	def column_div_form
		content_tag :div, class: 'col-xs-12 col-sm-8 col-md-8' do
			concat(form)
		end
	end

	def column_div_link
		content_tag :div, class:'col-xs-12 col-sm-4 col-md-4', style: 'text-align: right;' do
			concat(link)
		end
	end

	def form
		form_tag @path, :method => 'get', :id => "search_form", remote: true do
		  	content_tag :div, class:' form-inline' do
		  		concat( input_groups)
		  	end
		end
	end

	def link
		if !@link_path.nil? && @modal_id.nil?
			link_to "#{fa_icon('plus')} #{@link_text}".html_safe, @link_path, class:'btn btn-primary full-btn margin-btn'
		elsif !@link_path.nil? && !@modal_id.nil?
			link_to "#{fa_icon('plus')} #{@link_text}".html_safe, @link_path, class:'btn btn-primary full-btn margin-btn', remote: true, "data-toggle" => "modal", "data-target" => @modal_id
		end
	end

	def input_groups
		content_tag :div, class:'input-group' do
		  	concat(content_tag :div, 'Buscar', class:'input-group-addon')
		  	concat(text_field_tag :search, params[:search], class: 'form-control', size: 50, onkeyup: 'remoteSubmit("#search_form");', autofocus: true )
		  	concat(input_group_addon)
		end
	end

	def input_group_addon
		content_tag :div, class: 'input-group-addon' do
		  	concat(content_tag :span,'', class:'glyphicon glyphicon-search', aria:{hidden:'true'})
		end
	end
	### END SEARCH FORM CLIENTE #####


	### BEGIN PAGINATE ####
	def paginate resource, options = nil
		if not options
			@resource = resource
			content_tag :div, style: 'text-align: center;' do
				concat(will_paginate_helper)
				concat(javascript_paginate_helper)
			end
		end
	end
	def will_paginate_helper
		will_paginate @resource, :page_links => true,
		 							 :inner_window => 1,
		  							 :outer_window => 1,
		   							 :previous_label => '← Anterior',
		    						 :next_label => 'Siguiente →',
		     						 renderer: BootstrapPagination::Rails
	end

	def javascript_paginate_helper
		javascript_tag("$('ul.pagination a').click(function(){$.getScript(this.href); return false; });")
	end
	### END PAGINATE #####

	### BEGIN ERROR EXPLANATION ###
	def error_explanation object
		@object = object
		if not object.nil?
			content_tag :div do
				concat(errors_flash)
			end
		end
	end

	def errors_flash
		if @object.errors.any?
			content_tag :div, class: "alert alert-danger", role:"alert" do
				concat("<strong>Se produjeron los siguientes errores:</strong>".html_safe)
		      	concat(error_explanation_loop)
			end
		end
	end


	def error_explanation_loop
		content_tag :ul do
        	@object.errors.full_messages.each do |message|
	        	concat(li_message(message))
	        end
	    end
	end

	def li_message message
		content_tag :li do
    		"#{message}"
  		end
	end
	### BEGIN ERROR EXPLANATION ######

	def correo(client)
		link_to client.email , "mailto:"+client.email, target:"_top"
	end
  end
end
