module ClientEngine
  class Client < ApplicationRecord
    mount_uploader :avatar, AvatarUploader
    belongs_to :company
    has_many   :registries, foreign_key: :belongs_to

    def name
    	"#{last_name.titleize}, #{first_name.titleize}"
    end

    def address
    	read_attribute(:address).titleize unless read_attribute(:address).nil?
    end

    def full_address
      "#{address}.  - #{locality.titleize} - #{city.titleize} - #{country.titleize}"
    end

    #Metodo de busqueda de clientes por nombre, apellido o documento
    def self.search term
    	if term
      		where("LOWER(client_engine_clients.first_name || ' ' || client_engine_clients.last_name) LIKE LOWER(?) OR  client_engine_clients.document LIKE ?", "%#{term}%", "%#{term}%")
    	else
      		all
    	end
    end
  end
end
